"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var PersistContext_1 = __importDefault(require("./PersistContext"));
function PersistGate(_a) {
    var children = _a.children, persistor = _a.persistor, loading = _a.loading, onBeforeLift = _a.onBeforeLift;
    var _b = react_1.default.useState(false), bootstrapped = _b[0], setBootstrapped = _b[1];
    react_1.default.useEffect(function () {
        var unsubscribe = null;
        var handlePersistorState = function () {
            var bootstrapped = persistor.getState().bootstrapped;
            if (bootstrapped) {
                if (onBeforeLift) {
                    Promise.resolve(onBeforeLift()).finally(function () { return setBootstrapped(true); });
                }
                else {
                    setBootstrapped(true);
                }
                unsubscribe === null || unsubscribe === void 0 ? void 0 : unsubscribe();
            }
        };
        unsubscribe = persistor.subscribe(handlePersistorState);
        handlePersistorState();
        return function () {
            unsubscribe === null || unsubscribe === void 0 ? void 0 : unsubscribe();
        };
    }, [onBeforeLift, persistor]);
    return ((0, jsx_runtime_1.jsx)(PersistContext_1.default.Provider, __assign({ value: persistor }, { children: bootstrapped ? children : loading || null })));
}
exports.default = PersistGate;
